{//////////////////////////////////////////////////////////////////////////}
{                                                                          }
{        Portable DELPHI(tm) Compatible SYSUTILS UNIT FOR GPC              }
{                       !! INCOMPLETE !!                                   }
{                                                                          }
{    Copyright (C) 1997-2001 Free Software Foundation, Inc.                }
{                                                                          }
{    This file part of GNU Pascal.                                         }
{                                                                          }
{    Authors:                                                              }
{       Prof Abimbola A Olowofoyeku <African_Chief@bigfoot.com>            }
{       Frank Heckenbach <frank@pascal.gnu.de>                             }
{                                                                          }
{    NOTE - SOME OF THE ROUTINES IN THIS UNIT MAY NOT WORK CORRECTLY,      }
{    AND THERE ARE FUDGES: SO TEST EACH ROUTINE CAREFULLY !!!              }
{    Some things are missing, and there are some extras!                   }
{                                                                          }
{    This library is a free library; you can redistribute and/or modify    }
{    it under the terms of the GNU Library General Public License,         }
{    version 2, as published by the Free Software Foundation.              }
{                                                                          }
{    This library is distributed in the hope that it will be useful,       }
{    but WITHOUT ANY WARRANTY; without even the implied warranty of        }
{    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         }
{    GNU Library General Public License for more details.                  }
{                                                                          }
{    You should have received a copy of the GNU Library General Public     }
{    License along with this library (see the file COPYING.LIB);           }
{    if not, write to the Free Software Foundation, Inc., 675 Mass Ave,    }
{    Cambridge, MA 02139, USA.                                             }
{                                                                          }
{    As a special exception, if you link this file with files compiled     }
{    with a GNU compiler to produce an executable, this does not cause     }
{    the resulting executable to be covered by the GNU Library General     }
{    Public License. This exception does not however invalidate any other  }
{    reasons why the executable file might be covered by the GNU Library   }
{    General Public License.                                               }
{                                                                          }
{//////////////////////////////////////////////////////////////////////////}

{$gnu-pascal}

UNIT SYSUTILS;

INTERFACE

{  * @@
   * under Cygwin/Mingw32, if you don't want to use WinAPI routines but
   * you rather want to use the same routines as the other GPC versions,
   * then UNdefine "UseW32API" below
   * @@
}
{$ifdef _WIN32}
     {$define UseW32API}  { @@ defined by default under Cygwin/Mingw32 }
{$endif}

USES GPC, System;

{$X+}
{$I-}
{$B-}

CONST
SysError = - 1;
SingleQuote = '''';
DoubleQuote = '"';


{ data types }
TYPE
Word16 = Cardinal ( 16 );
Word32 = Cardinal ( 32 );
Word64 = Cardinal ( 64 );

Int16  = Integer  ( 16 );
Int32  = Integer  ( 32 );
Int64  = Integer  ( 64 );

Byte8  = Cardinal ( 8 );

TDosAttr = {$ifdef UseW32API}Int32{$else}Word{$endif};

GPC_AnyFile = AnyFile; { in order to have AnyFile parameters, while
                           AnyFile is redefined below }

TProcedure = PROCEDURE;

CONST
{ invalid file handle }
  NoFileHandle = SysError;
  BadFileHandle = NoFileHandle;

{ Days between 1/1/0001 and 12/31/1899 }
  DateDelta = 693594;

{  1/1/0001 is the last "good" date - any earlier date is "bad" }
  LastGoodDate = - 693593;

{ Seconds and milliseconds per min/hour/day }
  SecsPerMin  = 60;
  SecsPerHour = SecsPerMin * 60;
  SecsPerDay  = SecsPerHour * 24;
  MSecsPerSec = 1000;
  MSecsPerMin = SecsPerMin * MSecsPerSec;
  MSecsPerDay = SecsPerDay * MSecsPerSec;

{ pointer to empty string }
  EmptyStr = '';
  NullStr : PString = @EmptyStr;

{ for comparing values }
  LessThanValue = - 1;
  EqualsValue = 0;
  GreaterThanValue = 1;

{ for comparing values }
TYPE
TValueRelationship = LessThanValue .. GreaterThanValue;

{ Date/Time formatting variables }
TYPE
DTFormatStr = String [128];  { arbitrary length - should be long enough }

VAR
DateSeparator : Char = '/';          { separates different parts of date }
TimeSeparator : Char = ':';          { separates different parts of time }
TimeAMString  : DTFormatStr = 'am';
TimePMString  : DTFormatStr = 'pm';

LongTimeFormat  : DTFormatStr = 'hh:mm:ss';
ShortTimeFormat : DTFormatStr = 'h:mm';

ShortDateFormat : DTFormatStr = 'dd/mm/yy';
LongDateFormat  : DTFormatStr = 'dddd, dd MMMM yyyy';

ShortMonthNames : ARRAY [1..12] OF DTFormatStr =
( 'Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec' );

LongMonthNames : ARRAY [1..12] OF DTFormatStr =
( 'January', 'February', 'March', 'April', 'May', 'June', 'July',
'August', 'September', 'October', 'November', 'December' );

ShortDayNames : ARRAY [1..7] OF DTFormatStr =
( 'Sun', 'Mon', 'Tue', 'Wed', 'Thu', 'Fri', 'Sat' );

LongDayNames : ARRAY [1..7] OF DTFormatStr =
( 'Sunday', 'Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday' );


{ Date and time record }
TYPE
TTimeStamp = RECORD
    Time : Int32;      { Number of milliseconds since midnight }
    Date : Int32;      { One plus number of days since 1/1/0001 }
END;{ TTimeStamp }

TYPE
TFileHandle = PtrInt; { Integer of the same size as a pointer }
HandleFType = File;
PFile       = ^HandleFType;
TSysCharSet = Set OF Char;

LongRec = PACKED RECORD
{$ifdef __BYTES_BIG_ENDIAN__}
  Hi, Lo : Word16;
{$else}
  Lo, Hi : Word16;
{$endif}
END { LongRec };

WordRec = PACKED RECORD
{$ifdef __BYTES_BIG_ENDIAN__}
  Hi, Lo : Byte;
{$else}
  Lo, Hi : Byte;
{$endif}
END { WordRec };

{  date / time stuff  }
TDateTime = Double;

{ @@ not in Delphi }
TDateTimeRec = RECORD
   Date,
   Time : TDateTime;
END;

{$ifdef __OS_DOS__}
   {.$define __BP_TYPE_SIZES__} { dos platforms: affects sizes of things }
{$endif}

TFileName = {$ifdef __BP_TYPE_SIZES__}String ( 260 ) {$else}TString{$endif};

TFloatFormat = ( ffGeneral, ffExponent, ffFixed, ffNumber, ffCurrency );
TFloatValue  = ( fvExtended, fvCurrency );

TFileRec = RECORD
  Handle,
  Mode     : Integer;
  RecSize  : Word32;
  wPRIVATE : ARRAY [1..28] OF Byte;    { @@ 'private' in BP, Delphi, etc }
  UserData : ARRAY [1..32] OF Byte;
  Name     : ARRAY [0..259] OF Char;
END{ TFileRec };

TFloatRec = RECORD
  Exponent : Int16;
  Negative : Boolean;
  Digits   : ARRAY [0..20] OF Char;
END{ TFloatRec };

THeapStatus = RECORD
   TotalAddrSpace,
   TotalUncommitted,
   TotalCommitted,
   TotalAllocated,
   TotalFree,
   FreeSmall,
   FreeBig,
   Unused,
   Overhead,
   HeapErrorCode : Word32;
END { THeapStatus };

TMethod = RECORD
  Code,
  Data : Pointer;
END{ TMethod };


TYPE TSYSTEMTIME = RECORD
     wYear,
     wMonth,
     wDayOfWeek,
     wDay,
     wHour,
     wMinute,
     wSecond,
     wMilliseconds : Word16;
END { TSYSTEMTIME };

TYPE TFILETIME = RECORD
     dwLowDateTime,
     dwHighDateTime : Int32;
END { TFILETIME };
PFILETIME = ^TFILETIME;

TYPE
  { Search record used by FindFirst and FindNext }
  SearchRecFill = PACKED ARRAY [1..21] OF Byte8;
  SearchRec = {$ifdef __BP_TYPE_SIZES__} PACKED {$endif} RECORD
                Fill : SearchRecFill;
                Attr : Byte8;
                Time : Int32;
                {$ifdef __BP_TYPE_SIZES__}
                Size : Int32;
                Name : String [12]
                {$else}
                Size : LongInt;
                Name : TString;
                {$endif}
  END; { SearchRec }

{ @@ Date and time record used by PackFileDate and UnPackFileDate;
 * Use to unpack dates from FindFirst/FindNext }
DateTime = RECORD
  Year, Month, Day, Hour, Min, Sec : Word16
END; { DateTime }


{ WIN32 platform: valid values start from zero }
VAR Win32Platform : Integer = {$ifdef UseW32API} 0 {$else} SysError {$endif};

TYPE TWin32FindData = RECORD
     dwFileAttributes : Int32;
     ftCreationTime,
     ftLastAccessTime,
     ftLastWriteTime : TFILETIME;
     nFileSizeHigh,
     nFileSizeLow,
     dwReserved0,
     dwReserved1 : Int32;
     CFILENAME :  {$ifdef __BP_TYPE_SIZES__}ARRAY [0..259] OF CHAR {$else} TStringBuf {$endif};
     CALTERNATEFILENAME : {$ifdef __OS_DOS__}ARRAY [0..13] OF CHAR {$else} TStringBuf {$endif};
END { TWin32FindData };

{ @@ our very own unique TSearchRec fudge @@  }
TSearchRec = RECORD
  Time,
  Size,
  Attr : Int32;
  Name : TFileName;
  ExcludeAttr,                  { @@ Delphi compatibility @@ }
  FindHandle : Int32;           {  -- ditto -- }
  FindData   : TWin32FindData;  {  -- ditto -- }
  DosData    : SearchRec;       { @@ private (unique to GPC) field @@ }
END { TSearchRec };

{ ********* File/Directory searching routines ********* }

{ name clashes with DOS unit }
FUNCTION  FindFirst ( CONST Path : string; fAttr : Integer; VAR SR : TSearchRec ) : Integer;

FUNCTION  FindNext ( VAR SR : TSearchRec ) : Integer;

PROCEDURE FindClose ( VAR SR : TSearchRec );

{ ********* date/time routines ********* }

{ current date and time }
FUNCTION  Now : TDateTime;

{ current date }
FUNCTION  Date : TDateTime;

{ current time }
FUNCTION  Time : TDateTime;

{ day of week: 1 = Sunday; 7 = Saturday }
FUNCTION  DayOfWeek ( Date : TDateTime ) : Integer;

{ encoding/decoding dates/times }
PROCEDURE DecodeTime ( Time : TDateTime; VAR Hour, Min, Sec, MSec : Word16 );
FUNCTION  EncodeTime ( Hour, Min, Sec, MSec : Word ) : TDateTime;
PROCEDURE DecodeDate ( Date : TDateTime; VAR Year, Month, Day : Word16 );
FUNCTION  EncodeDate ( Year, Month, Day : Word ) : TDateTime;

{ converting dates and times }
FUNCTION  DateTimeToTimeStamp ( DateTime : TDateTime ) : TTimeStamp;
FUNCTION  TimeStampToDateTime ( CONST TimeStamp : TTimeStamp ) : TDateTime;
FUNCTION  MSecsToTimeStamp ( MSecs : Comp ) : TTimeStamp;
FUNCTION  TimeStampToMSecs ( CONST TimeStamp : TTimeStamp ) : Comp;

FUNCTION  FileDateToDateTime ( DosDateTime : Longint ) : TDateTime;
FUNCTION  DateTimeToFileDate ( MyDateTime : TDateTime ) : Int32;

{ not in Delphi v2 }
FUNCTION  SystemTimeToDateTime ( CONST SystemTime : TSystemTime ) : TDateTime;

{ not in Delphi v2 }
PROCEDURE DateTimeToSystemTime ( DateTime : TDateTime; VAR STime : TSystemTime );

{ @@ unpack a Dos file date/time into its component parts : not in Delphi!! }
PROCEDURE UnPackFileDate ( P : Longint; VAR T : DateTime );

{ @@ pack date/time components into a Dos filetime }
PROCEDURE PackFileDate ( CONST T : DateTime; VAR P : Longint );

{ @@ encode a packed dos time into two TDateTimes - Date + Time }
FUNCTION  LongtoDateTimeRec ( i : Longint ) : TDateTimeRec;

{ @@ decode and pack two TDateTimes into a dos time format }
FUNCTION  DateTimeRecToLong ( DT : TDateTimeRec ) : Integer;

{ @@ convert a filedate to a string, using the current values of
  the date/time formatting variables }
FUNCTION  FileDateToStr ( FTime : Longint ) : TString;

FUNCTION CompareDateTime ( CONST A, B : TDateTime ) : TValueRelationship;

FUNCTION CompareDate ( CONST A, B : TDateTime ) : TValueRelationship;

FUNCTION CompareTime ( CONST A, B : TDateTime ) : TValueRelationship;

FUNCTION SameDate ( CONST A, B : TDateTime ) : Boolean;

FUNCTION SameTime ( CONST A, B : TDateTime ) : Boolean;

FUNCTION SameDateTime ( CONST A, B : TDateTime ) : Boolean;

FUNCTION LastDelimiter ( CONST Delimiters, S : string ) : Integer;

FUNCTION IsPathDelimiter ( CONST S : string; Index : Integer ) : Boolean;

FUNCTION IsDelimiter ( CONST Delimiters, S : string; Index : Integer ) : Boolean;


{ converting and formatting dates/times to strings }
FUNCTION  TimeToStr ( Time : TDateTime ) : TString;
FUNCTION  DateToStr ( Date : TDateTime ) : TString;
FUNCTION  DateTimeToStr ( DateTime : TDateTime ) : TString;
FUNCTION  FormatDateTime ( CONST Format : string; DateTime : TDateTime ) : TString;
FUNCTION  FormatDate ( Format : String; Date : TDateTime ) : TString;
{@@}FUNCTION  wFormatTime ( Format : String; Time : TDateTime ) : TString;


{ other stuff }

TYPE
TTextBuf = ARRAY [0..128] OF Char;
TTextRec = RECORD
  Handle,
  Mode : Int32;
  BufSize,
  BufPos,
  BufEnd : Word32;
  BufPtr : PChar;
  OpenFunc,
  InOutFunc,
  FlushFunc,
  CloseFunc : Pointer;
  UserData : ARRAY [1..32] OF Byte;
  Name : ARRAY [0..259] OF Char;
  Buffer : TTextBuf;
END { TTextRec };

{ file attribute constants }
CONST
faNormal      = $00;
faReadOnly    = $01;
faHidden      = $02;
faSysFile     = $04;
faVolumeID    = $08;
faDirectory   = $10;
faArchive     = $20;
faAnyFile     = $3F;

{ file access modes }
CONST
fmOpenRead       = $0000;
fmOpenWrite      = $0001;
fmOpenReadWrite  = $0002;
fmShareCompat    = $0000;
fmShareExclusive = $0010;
fmShareDenyWrite = $0020;
fmShareDenyRead  = $0030;
fmShareDenyNone  = $0040;


{ ******* string routines ********* }
{ is the string "S" a valid Pascal identifier? }
FUNCTION IsValidIdent ( CONST s : string ) : Boolean;

{ adjust all line breaks in "S" to true CR/LF sequences }
FUNCTION AdjustLinesBreaks ( CONST S : string ) : Tstring;

{ ******* Pascal string routines ******* }

{ Add single quote to beginning and end of S and repeat any single
  quote found within S }
FUNCTION QuotedStr ( S : string ) : TString;

{ Return whether the specified string was passed at the command line.
  * SwitchChars identifies valid argument-delimiter characters.
  * IgnoreCase specifies whether a case-sensitive or case-insensitive
    search is performed.
}
FUNCTION FindCmdLineSwitch ( CONST Switch : String; SwitchChars :
TSysCharSet; IgnoreCase : Boolean ) : Boolean;

{ @@ name clashes with GPC.PAS }
{ return a string stripped of leading spaces }
{@@}FUNCTION  wTrimLeft ( CONST s : String ) : TString;

{ return a string stripped of trailing spaces }
{@@}FUNCTION  wTrimRight ( CONST s : String ) : TString;

{ return a string stripped of leading and trailing spaces }
FUNCTION  Trim ( CONST s : String ) : TString;

{ dynamically allocate a string }
FUNCTION  NewStr ( CONST S : string ) : PString;
asmname '_p_newstring';

{ allocate memory for a string pointer and assign a value to it}
PROCEDURE AssignStr ( VAR Result : PString; CONST Value : String );

{ append a string }
PROCEDURE AppendStr ( VAR Result : String; CONST Src : String );

{ dispose of a dynamically allocated string }
PROCEDURE DisposeStr ( P : PString );
asmname '_p_dispose';

{ case insensitive string comparison}
FUNCTION  CompareText ( CONST S1, S2 : string ) : Integer;
asmname '_p_comparetext';

{ case sensitive string comparison}
FUNCTION  CompareStr ( CONST S1, S2 : string ) : Integer;
asmname '_p_comparestr';

{ supposed to use language driver, but here, it doesn't }
FUNCTION  AnsiCompareText ( CONST S1, S2 : string ) : Integer;
asmname '_p_comparetext';

{ supposed to use language driver, but here, it doesn't }
FUNCTION  AnsiCompareStr ( CONST S1, S2 : string ) : Integer;
asmname '_p_comparestr';

{ case insensitive comparison = are they the same? }
FUNCTION AnsiSameText ( CONST S1, S2 : string ) : Boolean;

{ case sensitive comparison = are they the same? }
FUNCTION AnsiSameStr ( CONST S1, S2 : string ) : Boolean;

{ convert a string to uppercase }
FUNCTION  UpperCase ( CONST c : string ) : TString;
asmname '_p_upcase_str';

{ convert a string to lowercase }
FUNCTION  LowerCase ( CONST c : string ) : TString;
asmname '_p_locase_str';

{ convert a string to uppercase }
FUNCTION  AnsiUpperCase ( CONST S : string ) : Tstring;
asmname '_p_upcase_str';

{ convert a string to lowercase }
FUNCTION  AnsiLowerCase ( CONST S : string ) : Tstring;
asmname '_p_locase_str';

{ * string and number conversions * }

{ convert an integer to a string }
FUNCTION IntToStr ( i : longestint ) : TString;

{ convert a floating point number to a string }
FUNCTION FloatToStr ( Value : Extended ) : TString;

{ convert a string to an integer }
FUNCTION StrToInt ( CONST s : String ) : longestint;
asmname '_p_strtoint';

FUNCTION StrToInt64 ( CONST s : String ) : longestint; { same as above }
asmname '_p_strtoint';

{ convert a string to an integer, returning "Default" in cases of error }
FUNCTION StrToIntDef ( CONST S : string; Default : longestint ) : longestint;
asmname '_p_strtointdef';

FUNCTION StrToInt64Def ( CONST S : string; Default : longestint ) : longestint;
asmname '_p_strtointdef';

{ convert a string to floating point }
FUNCTION StrToFloat ( CONST S : string ) : Extended;

{ @@ not in Delphi: convert a string to a set of char }
FUNCTION StringtoCharset ( CONST S : string; VAR c : TSysCharSet ) : Boolean;

{ convert an integer to Hex; dummydigits does nothing !!!}
FUNCTION IntToHex ( L, DummyDigits : Integer ) : TString;

{ ******* null terminated (C) string routines ******* }
FUNCTION  StrLen          ( Src : CString ) : SizeType;
asmname '_p_strlen';

FUNCTION  StrEnd          ( Src : CString ) : CString;
asmname '_p_strend';

FUNCTION  StrComp         ( s1, s2 : CString ) : Integer;
asmname '_p_strcmp';

FUNCTION  StrLComp        ( s1, s2 : CString; MaxLen : SizeType ) : Integer;
asmname '_p_strlcmp';

FUNCTION  StrIComp        ( s1, s2 : CString ) : Integer;
asmname '_p_strcasecmp';

         {@@ supposed to use Windows locale }
FUNCTION  AnsiStrIComp        ( s1, s2 : CString ) : Integer;
asmname '_p_strcasecmp';

FUNCTION  StrLIComp       ( s1, s2 : CString; MaxLen : SizeType ) : Integer;
asmname '_p_strlcasecmp';

FUNCTION  StrCopy         ( Dest, Source : CString ) : CString;
asmname '_p_strcpy';

FUNCTION  StrPCopy   ( Dest : CString; CONST Source : String ) : CString;
asmname '_p_cstringcopystring';

FUNCTION  StrECopy        ( Dest, Source : CString ) : CString;
asmname '_p_strecpy';

FUNCTION  StrLCopy        ( Dest, Source : CString; MaxLen : SizeType ) : CString;
asmname '_p_strlcpy';
                                {! source should actually be a Pascal string here!  }
FUNCTION  StrPLCopy        ( Dest, Source : CString; MaxLen : SizeType ) : CString;
asmname '_p_strlcpy';

FUNCTION  StrMove         ( Dest, Source : CString; Count : SizeType ) : CString;
asmname '_p_strmove';

FUNCTION  StrCat          ( Dest, Source : CString ) : CString;
asmname '_p_strcat';

FUNCTION  StrLCat         ( Dest, Source : CString; MaxLen : SizeType ) : CString;
asmname '_p_strlcat';

FUNCTION  StrScan         ( Src : CString; Ch : Char ) : CString;
asmname '_p_strscan';

FUNCTION  StrRScan        ( Src : CString; Ch : Char ) : CString;
asmname '_p_strrscan';

FUNCTION  StrPos          ( Str, SubStr : CString ) : CString;
asmname '_p_strpos';

FUNCTION  StrUpper        ( s : CString ) : CString;
asmname '_p_strupper';

FUNCTION  StrLower        ( s : CString ) : CString;
asmname '_p_strlower';

{ @@ supposed to use Windows locale }
FUNCTION  AnsiStrUpper        ( s : CString ) : CString;
asmname '_p_strupper';

{ @@ supposed to use Windows locale }
FUNCTION  AnsiStrLower        ( s : CString ) : CString;
asmname '_p_strlower';

FUNCTION  StrNew          ( Src : CString ) : CString;
asmname '_p_strdup';

PROCEDURE StrDispose      ( s : CString );
asmname '_p_dispose';

FUNCTION StrPas ( Src : pChar ) : TString;
{asmname '_p_strpas';}

{ return a pointer to next string }
FUNCTION  StrNext  ( Str : pChar ) : pChar;

{ return a pointer to previous string }
FUNCTION  StrPrev  ( Str : pChar ) : pChar;

{ **** file and directory routines ***** }

{ return S with trailing slash if none already exists, else return S }
FUNCTION IncludeTrailingBackslash ( CONST S : string ) : TString;
asmname '_p_forceadddirseparator';

{ -- ditto -- }
FUNCTION IncludeTrailingDelimiter ( CONST S : string ) : TString;
asmname '_p_forceadddirseparator';

{ return just the extension }
FUNCTION  ExtractFileExt ( CONST s : string ) : TString;
asmname '_p_ext_from_path';

{ return just the path name part }
FUNCTION  ExtractFileDir ( CONST s : string ) : TString;

{ return just the file name part }
FUNCTION  ExtractFileName ( s : string ) : TString;
{asmname '_p_name_from_path';}

{ return the path + trailing slash }
FUNCTION  ExtractFilePath ( CONST s : string ) : TString;

{ return the drive name only }
FUNCTION  ExtractFileDrive ( CONST s : string ) : Tstring;

{ change the extension of a file }
FUNCTION  ChangeFileExt ( s, Ext : string ) : TString;

{ return the full path name }
FUNCTION  ExpandFileName ( CONST s : string ) : TString;
asmname '_p_fexpand';

{ does a file exist ?}
FUNCTION  FileExists ( CONST s : string ) : Boolean;
AsmName '_p_file_exists';

{ does a directory exist? }
FUNCTION  DirectoryExists ( CONST DirName : String ) : Boolean;
asmname '_p_directory_exists';

FUNCTION  FileSearch ( CONST FileName, DirList : String ) : TString;
asmname '_p_fsearch';

{ name clash with DOS unit }
{@@}FUNCTION DiskSize ( Drive : Byte ) : Longint;

{@@}FUNCTION DiskFree ( Drive : Byte ) : Longint;

{ *****  misc ****** }

{@@ name clash with GPC unit}
FUNCTION  wIsLeapYear ( Year : Integer ) : Boolean;
asmname '_p_is_leap_year';

{ create a directory - return whether successful }
FUNCTION CreateDir ( CONST s : String ) : Boolean;

{ remove a directory - return whether successful }
FUNCTION RemoveDir ( CONST s : String ) : Boolean;

{ change to a directory - return whether successful }
FUNCTION SetCurrentDir ( CONST s : String ) : Boolean;

{ return the current directory }
FUNCTION  GetCurrentDirectory : TString;
asmname '_p_get_current_directory';

{ -- ditto -- }
FUNCTION  GetCurrentDir : TString;
asmname '_p_get_current_directory';


{ make a noise }
PROCEDURE Beep;

{ set an exit procedure }
PROCEDURE AddExitProc ( Proc : TProcedure ); asmname '_p_atexit';

{ ******* file routines: using string parameters ***** }
{ rename a file }
FUNCTION  RenameFile ( CONST OldName, NewName : string ) : Boolean;

{ delete a file }
FUNCTION  DeleteFile ( CONST FileName : string ) : Boolean;

{ return the date of a file }
FUNCTION  FileAge ( CONST FileName : String ) : Longint;

{ set the file attribute }
FUNCTION  FileSetAttr ( CONST FileName : String; Attr : TDosAttr )  : integer;

{ get the file attribute }
FUNCTION  FileGetAttr ( CONST FileName : String ) : TDosAttr;

{ @@ set the date/time of a file: not in Delphi @@ }
FUNCTION  FileSetTime ( CONST FileName : String; aTime : integer ) : Integer;

{ ********* file routines: using file handles ******* }

{** handle-returning and conversion routines ** }

{ !! return the sysutils internal file handle for a file !!
  * the returned handle is only compatible with the sysutils file routines
    that take numeric handles (see below)
  * note: do not use the returned handle for libc file functions or
          OS API file functions.
  *       for libc-compatible or API-compatible file handles, use the
          conversion routines below ...
  *       note: you might need to amend "GetOSFileHandle" for your OS.
}
FUNCTION  SysUtilsFileHandle ( VAR f : File ) : TFileHandle;

{ !! return an operating system API-compatible file handle !!
  * under WIN32:  returns a handle that is compatible with WinAPI file routines only
  * under others: returns a handle that is compatible with libc file routines
}
FUNCTION  GetOSFileHandle ( VAR f ) : Integer;

{ !! convert a sysutils file handle to a libc file handle !! }
FUNCTION  SysUtilsFileHandle2LibcFileHandle ( Handle : TFileHandle ) : Integer;

{ !! convert a sysutils file handle to an API-compatible file handle !! }
FUNCTION  SysUtilsFileHandle2OSFileHandle ( Handle : TFileHandle ) : Integer;

{ ** routines that use SysUtils file handles ** }
{ write to a file }
FUNCTION FileWrite  ( Handle : TFileHandle; CONST Buf; Count : integer ) : integer;

{ read from a file }
FUNCTION FileRead   ( Handle : TFileHandle; VAR Buf; Count : integer ) : integer;

{ open a file }
FUNCTION FileOpen   ( CONST Fname : string; Mode : integer ) : TFileHandle;

{ create a file and return its handle }
FUNCTION FileCreate ( CONST Fname : string ) : TFileHandle;

{ position the file pointer to "offset" }
FUNCTION FileSeek ( Handle : TFileHandle; offset : Integer; origin : Integer ) : Integer;

{ close a file }
PROCEDURE FileClose  ( Handle : TFileHandle );

{ return the date of a file }
FUNCTION  FileGetDate ( handle : TFileHandle ) : Longint;

{ set the date of a file }
PROCEDURE FileSetDate ( handle : TFileHandle; aDate : Integer );

{ ********* memory routines *********** }
{ allocate a memory block on the heap and return pointer to it }
FUNCTION AllocMem ( Size :  Cardinal ) : Pointer;

{ @@ other utility functions: not in Delphi @@ }
FUNCTION  MakeWord64 ( aLow, aHi : Int32 ) : Word64;
FUNCTION  MakeInt64 ( aLow, aHi : Int32 ) : Int64;
FUNCTION  MakeInt32 ( A, B : Word16 ) : Int32;
FUNCTION  MakeWord16 ( A, B : Byte ) : Word16;

FUNCTION  LoLong ( L : Int64 ) : Int32;
FUNCTION  HiLong ( L : Int64 ) : Int32;

FUNCTION  HiWord32 ( L : Int64 ) : Word32;
FUNCTION  LoWord32 ( L : Int64 ) : Word32;

FUNCTION  HiWord16 ( L : Int32 ) : Word16;
FUNCTION  LoWord16 ( L : Int32 ) : Word16;

FUNCTION  HiByte8 ( W : Word16 ) : Byte8;
FUNCTION  LoByte8 ( W : Word16 ) : Byte8;

{ find all occurrences of "theold" and replace with "thenew" }
FUNCTION  FindAndReplace ( CONST Src, TheOld, TheNew : String; IgnoreCase, WholeWords : Boolean ) : TString;

IMPLEMENTATION

{ copy certain parts of Dos unit for all platforms }
{$i fromdos.inc}

{ constants, types
  GetDate
  GetTime
  GetFattr
  PackTime
  UnpackTime
  GetFTime
  SetFTime
  DiskSize
  DiskFree
  (we can use amended versions of FindFirst/FindNext - except under Windows
   where we need the FindData field of TSearchRec - hence need to use API)
}

{ @@ platform-specific stuff:
      for FindFirst/FindNext/FindClose
      and file attributes stuff
  @@
}

{$ifdef UseW32API}
  {$i win.inc}
{$else}
  {$i others.inc}
{$endif}{ UseW32API }

FUNCTION  wTrimLeft ( CONST s : String ) : TString;
VAR i : Integer;
BEGIN
  i := 1;
  Result := s;
  WHILE ( i <= Length ( Result ) ) AND ( Result [i] <= ' ' ) DO Inc ( i );
  Delete ( Result, 1, Pred ( i ) );
END;{* TrimLeft *}

FUNCTION wTrimRight ( CONST s : String ) : TString;
VAR i : Integer;
BEGIN
  i := Length ( Result );
  WHILE ( i > 0 ) AND ( Result [i] <= ' ' ) DO Dec ( i );
  Delete ( Result, Succ ( i ), Length ( Result ) - i );
END;{* TrimRight *}

FUNCTION Trim ( CONST s : String ) : TString;
VAR i : Integer;
BEGIN
  i := 1;
  Result := s;
  WHILE ( i <= Length ( Result ) ) AND ( Result [i] <= ' ' ) DO Inc ( i );
  Delete ( Result, 1, Pred ( i ) );

  i := Length ( Result );
  WHILE ( i > 0 ) AND ( Result [i] <= ' ' ) DO Dec ( i );
  Delete ( Result, Succ ( i ), Length ( Result ) - i );
END;{* Trim *}

PROCEDURE AssignStr ( VAR Result : PString; CONST Value : String );
BEGIN
  DisposeStr ( Result );
  Result := NewStr ( Value );
END;{* AssignStr *}

PROCEDURE AppendStr ( VAR Result : String; CONST Src : String );
BEGIN
  Result := Concat ( Result, Src );
END;{* AppendStr *}

PROCEDURE UnPackFileDate ( P : Longint; VAR T : DateTime );
BEGIN
  UnpackTime ( p, t );
END;{* UnPackFileDate *}

PROCEDURE PackFileDate ( CONST T : DateTime; VAR P : Longint );
BEGIN
  PackTime ( t, p );
END;{* PackFileDate *}

FUNCTION Date : TDateTime;
VAR
Year, Month, Day,
DayOfWeek : Word;
BEGIN
  GetDate ( Year, Month, Day, DayOfWeek );
  Result := EncodeDate ( Year, Month, Day );
END;{* Date *}

FUNCTION Time : TDateTime;
VAR
Hour, Minute,
Second, Sec100 : Word;
BEGIN
  GetTime ( Hour, Minute, Second, Sec100 );
  Result := EncodeTime ( Hour, Minute, Second, Sec100 );
END;{* Time *}

FUNCTION Now : TDateTime;
VAR
T : TDateTime;
BEGIN
    T := Time;
    Result := Date + T;
END;{* Now *}

FUNCTION  ChangeFileExt ( s, Ext : string ) : Tstring;
VAR
i : integer;
BEGIN

   { see if 's' already has an extension }
   i  := pos ( '.', s );
   IF ( i = 1 ) { some unix filenames begin with dot ! }
   THEN BEGIN
      i  := pos ( '.', Copy ( s, 2, Length ( s ) ) );
   END;

   { remove the extension }
   IF i > 1 THEN s := Copy ( s, 1, pred ( i ) );

   IF Ext = '' THEN Result := s
   ELSE BEGIN
      IF ( Ext [1] <> '.' )
      THEN Result := s + '.' + Ext
      ELSE Result := s + Ext;
   END;
END;{*  ChangeFileExt *}

FUNCTION  StrNext  ( Str : pChar ) : pChar;
BEGIN
  Result := Succ ( Str );
END; {* StrNext *}

FUNCTION  StrPrev  ( Str : pChar ) : pChar;
BEGIN
   Result := Pred ( Str );
END; {* StrPrev *}

FUNCTION StrPas ( Src : pChar ) : TString;
BEGIN
  StrPas := CString2String ( Src )
END; {* StrPas *}

FUNCTION RenameFile ( CONST OldName, NewName : string ) : Boolean;
VAR
f : file;
BEGIN
   Assign ( f, OldName );
   Rename ( f, NewName );
   Result := IoResult = 0;
END; {* RenameFile *}

FUNCTION DeleteFile ( CONST FileName : string ) : Boolean;
VAR
f : file;
BEGIN
   Assign ( f, FileName );
   Erase ( f );
   Result := IoResult = 0;
END; {* DeleteFile *}

FUNCTION SysUtilsFileHandle;
BEGIN
  Result := TFileHandle ( @f );
END; {* SysUtilsFileHandle *}

FUNCTION  GetOSFileHandle;
BEGIN
 Result := {$ifdef UseW32API}cfHandle2osfHandle{$endif} ( FileHandle ( f ) );
END; {* GetOSFileHandle *}

FUNCTION  SysUtilsFileHandle2OSFileHandle ( Handle : TFileHandle ) : Integer;
VAR
p : PFile;
BEGIN
  Result := NoFileHandle;
  IF Handle <> NoFileHandle
  THEN BEGIN
      p := PFile ( Handle );
      Result := GetOSFileHandle ( p^ );
  END;
END; {* SysUtilsFileHandle2OSFileHandle *}

FUNCTION  SysUtilsFileHandle2LibcFileHandle ( Handle : TFileHandle ) : Integer;
VAR
p : PFile;
BEGIN
  Result := NoFileHandle;
  IF Handle <> NoFileHandle
  THEN BEGIN
      p := PFile ( Handle );
      Result := FileHandle ( GPC_AnyFile ( p^ ) );
  END;
END; {* SysUtilsFileHandle2LibcFileHandle *}

FUNCTION sys_fCreate ( CONST Fname : String; isNew : Boolean; Mode : integer ) : TFileHandle;
VAR
f   : pFile;
old : integer;
BEGIN
  New ( f );
  Assign ( f^, FName );
  IF IsNew THEN BEGIN
     ReWrite ( f^, 1 );
  END ELSE BEGIN
      old := FileMode;
      FileMode := Mode;
      Reset ( f^, 1 );
      FileMode := Old;
  END;

  IF IOResult <> 0
  THEN BEGIN
     Dispose ( f );
     Result := NoFileHandle
  END ELSE Result := SysUtilsFileHandle ( f^ );
END;{ * sys_fCreate *}

FUNCTION FileCreate ( CONST Fname : string ) : TFileHandle;
BEGIN
    Result := sys_fCreate ( FName, TRUE, 2 );
END;{* FileCreate *}

FUNCTION FileOpen   ( CONST Fname : string; Mode : integer ) : TFileHandle;
BEGIN
    Result := sys_fCreate ( FName, False, Mode );
END;{* FileOpen *}

PROCEDURE FileClose ( Handle : TFileHandle );
VAR p : PFile;
BEGIN
  IF Handle <> NoFileHandle
  THEN BEGIN
      p := PFile ( Handle );
      Close ( p^ );
      IF IoResult <> 0 THEN;
      Dispose ( p );
    END;
END;{* FileClose *}

FUNCTION FileWrite  ( Handle : TFileHandle; CONST Buf; Count : integer ) : integer;
VAR
p : PFile;
i : Integer;
BEGIN
  Result := NoFileHandle;
  IF Handle <> NoFileHandle
  THEN BEGIN
      p := PFile ( Handle );
      BlockWrite ( p^, Buf, Count, i );
      IF IoResult = 0 THEN Result := i;
  END;
END;{* FileWrite *}

FUNCTION FileRead   ( Handle : TFileHandle; VAR Buf; Count : integer ) : integer;
VAR
p : PFile;
i : Integer;
BEGIN
  Result := NoFileHandle;
  IF Handle <> NoFileHandle
  THEN BEGIN
      p := PFile ( Handle );
      BlockRead ( p^, Buf, Count, i );
      IF IoResult = 0 THEN Result := i;
  END;
END;{* FileRead *}

FUNCTION FileSeek ( Handle : TFileHandle; offset : Integer; origin : Integer ) : Integer;
VAR
p : PFile;
l : integer;
BEGIN
  Result := NoFileHandle;
  IF Handle <> NoFileHandle
  THEN BEGIN
      p := PFile ( Handle );
      l := Offset;
      CASE origin OF
         0 : { do nothing - seek from beginning of file };
         1 : l := FilePos ( p^ ) + Offset;  { from current position }
         2 : l := FileSize ( p^ ) + Offset; { from end of file }
      END;
      Seek ( p^, l );
      IF IoResult = 0 THEN Result := FilePos ( p^ );
  END;
END;{* FileSeek *}

FUNCTION  FileGetAttr;
VAR
Attr : TDosAttr;
f : GPC_AnyFile;
BEGIN
  {$ifdef UseW32API}
   Attr := GetFileAttributes ( FileName );
  {$else}
   Assign ( f, FileName );
   GetFattr ( f, Attr );
  {$endif}
   Result := Attr;
END;{* FileGetAttr *}

FUNCTION  FileSetAttr;
VAR
f : GPC_AnyFile;
BEGIN
  {$ifdef UseW32API}
   DosError := Ord ( SetFileAttributes ( FileName, Attr ) );
  {$else}
   Assign ( f, FileName );
   SetFattr ( f, Attr );
  {$endif}
   Result := DosError;
END;{* FileSetAttr *}

FUNCTION  FileAge ( CONST FileName : String ) : Longint;
VAR
F : GPC_AnyFile;
L : Longint;
BEGIN
   Result := SysError;
   Assign ( F, FileName );
   GetFTime ( F, L );
   IF DosError = 0 THEN Result := L;
END;{* FileAge *}

FUNCTION  FileGetDate ( Handle : TFileHandle ) : Longint;
VAR
p : PFile;
BEGIN
  Result := NoFileHandle;
  IF Handle <> NoFileHandle
  THEN BEGIN
      p := PFile ( Handle );
      Result := FileAge ( FileName ( GPC_AnyFile ( p^ ) ) );
  END;
END;{* FileGetDate *}

PROCEDURE FileSetDate ( handle : TFileHandle; aDate : Integer );
VAR
p : PFile;
BEGIN
  IF Handle <> NoFileHandle
  THEN BEGIN
      p := PFile ( Handle );
      SetFTime ( GPC_AnyFile ( p^ ), aDate );
  END;
END;{* FileSetDate *}

FUNCTION  FileSetTime ( CONST FileName : String; aTime : integer ) : Integer;
VAR
f : GPC_AnyFile;
BEGIN
  Result := SysError;
  Assign ( f, FileName );
  Reset ( f );
  IF Ioresult = 0
  THEN BEGIN
     SetFTime ( f, aTime );
     Result := DosError;
     Close ( f );
  END;
END;{* FileSetTime *}

FUNCTION AllocMem ( Size :  Cardinal ) : Pointer;
VAR
p : Pointer;
BEGIN
   GetMem ( p, Size );
   {$W-}FillChar ( p^, Size, 0 );{$W+}
   Result := p;
END;{* AllocMem *}

{$W-}
FUNCTION IntToStr ( i : longestint ) : TString;
BEGIN
  Str ( i, Result );
END; {* IntToStr  *}

FUNCTION FloatToStr ( Value : Extended ) : TString;
BEGIN
  Str ( Value, Result );
END; {* FloatToStr  *}
{$W+}

FUNCTION StrToInt ( CONST s : String ) : longestint;
VAR
Code : Integer;
BEGIN
    Val ( s, Result, Code );
    IF Code <> 0 THEN IOError ( EConvertError );
END; {* StrToInt *}

FUNCTION StrToIntDef;
VAR
Code : Integer;
BEGIN
    Val ( s, Result, Code );
    IF Code <> 0 THEN Result := Default;
END; {* StrToIntDef *}

FUNCTION  ExtractFileDir ( CONST s : string ) : TString;
BEGIN
   Result := RemoveDirSeparator ( DirFromPath ( s ) );
END; {* ExtractFileDir *}

FUNCTION  ExtractFilePath ( CONST s : string ) : TString;
BEGIN
   Result := ForceAddDirSeparator ( DirFromPath ( s ) );
END; {* ExtractFilePath *}

FUNCTION  ExtractFileName ( s : string ) : TString;
VAR
i : Word;
BEGIN
  FOR i := length ( s ) DOWNTO 1
  DO BEGIN
      IF s [i] IN [':', DirSeparator]
      THEN BEGIN
         Delete ( s, 1, i );
         Break;
      END;
  END;
  Result := s;
END;  {* ExtractFileName *}

FUNCTION ExtractFileDrive ( CONST s : string ) : Tstring;
BEGIN
  Result := GetMountPoint ( s );
END; {* ExtractFileDrive *}

{ case insensitive compare }
FUNCTION CompareText ( CONST S1, S2 : string ) : Integer;
BEGIN
   Result := StrIComp ( s1, s2 );
END {* CompareText *};

{ case sensitive compare }
FUNCTION CompareStr ( CONST S1, S2 : string ) : Integer;
BEGIN
   Result := StrComp ( s1, s2 );
END {*  CompareStr *};

FUNCTION  SetCurrentDir ( CONST s : String ) : Boolean;
BEGIN
    ChDir ( s );
    Result := IoResult = 0;
END; {* SetCurrentDir *}

FUNCTION  CreateDir ( CONST s : String ) : Boolean;
BEGIN
    MkDir ( s );
    Result := IOResult = 0;
END; {* CreateDir *}

FUNCTION  RemoveDir ( CONST s : String ) : Boolean;
BEGIN
    RmDir ( s );
    Result := IOResult = 0;
END; {* RemoveDir *}

PROCEDURE Beep;
BEGIN
   Write ( #7 );
END; {* Beep *}


TYPE
LRec = RECORD
{$ifdef __BYTES_BIG_ENDIAN__}
  HW, LW : Word16;
{$else}
  LW, HW : Word16;
 {$endif}
END;

TYPE
String4 = String [4];

FUNCTION HexW ( W : Word16 ) : String4;
CONST
Digits : ARRAY [0..$F] OF Char = '0123456789ABCDEF';
BEGIN
    Result := '1234'; { length of 4 }
    Result [1] := Digits [hi ( W ) SHR 4];
    Result [2] := Digits [hi ( W ) AND $F];
    Result [3] := Digits [lo ( W ) SHR 4];
    Result [4] := Digits [lo ( W ) AND $F];
END;

FUNCTION IntToHex ( L, DummyDigits : Integer ) : TString;
BEGIN
    WITH LRec ( L ) DO Result := HexW ( HW ) + HexW ( LW );
END; {* IntToHex *}

FUNCTION AdjustLinesBreaks ( CONST S : string ) : TString;
CONST
Cr = #13;
Lf = #10;
VAR
i, j : integer;
Ch, Ch2 : Char;
BEGIN
   Result := '';
   j := Length ( s );
   FOR i := 1 TO j
   DO BEGIN
      ch := s [i];
      IF i = 1 THEN Ch2 := #0 ELSE ch2 := s [ Pred ( i ) ];
      IF ( Ch = Lf ) AND ( Ch2 <> Cr ) { Lf not preceded by Cr }
      OR ( Ch2 = Cr ) AND ( Ch <> Lf ) { Cr not followed by Lf }
      THEN BEGIN
           Result := Result + Cr + Lf;
      END
      ELSE Result := Result + Ch;
   END;
END; {* AdjustLinesBreaks *}

FUNCTION IsValidIdent ( CONST s : string ) : Boolean;
VAR
b : boolean;
i : integer;
BEGIN
    b := True;
    FOR i := 1 TO length ( s ) DO BEGIN
        IF s [i] IN ['A'..'Z', 'a'..'z', '_', '0'..'9'] THEN {valid chars}
        ELSE BEGIN
           b := False;
           Break;
        END;
    END;
    Result := ( b = true ) AND ( s [1] IN ['A'..'Z', 'a'..'z', '_'] );
END; {* IsValidIdent *}

FUNCTION StrToFloat ( CONST S : string ) : Extended;
VAR
Code : Integer;
BEGIN
  Val ( s, Result, Code );
  IF Code <> 0 THEN IOError ( EConvertError );
END; {* StrToFloat *}

FUNCTION MakeWord64 ( aLow, aHi : Int32 ) : Word64;
BEGIN
  Result := Word64 ( Word64 ( aLow ) OR Word64 ( aHi ) SHL BitSizeOf ( Int32 ) );
END; {* MakeWord64 *}

FUNCTION MakeInt64 ( aLow, aHi : Int32 ) : Int64;
BEGIN
  Result := Int64 ( Word64 ( Word32 ( aLow ) ) OR Word64 ( Word32 ( aHi ) ) SHL BitSizeOf ( Int32 ) )
END; {* MakeInt64 *}

FUNCTION HiLong ( L : Int64 ) : Int32;
BEGIN
  Result := Int32 ( L SHR BitSizeOf ( Int32 ) );
END; {* HiLong *}

FUNCTION LoLong ( L : Int64 ) : Int32;
BEGIN
  Result := Int32 ( L AND $FFFFFFFF );
END; {* LoLong *}

FUNCTION HiWord32 ( L : Int64 ) : Word32;
BEGIN
  Result := Word32 ( L SHR BitSizeOf ( Word32 ) );
END; {* HiWord32 *}

FUNCTION LoWord32 ( L : Int64 ) : Word32;
BEGIN
  Result := Word32 ( L AND $FFFFFFFF );
END; {* LoWord32 *}

FUNCTION MakeWord16 ( A, B : Byte ) : Word16;
BEGIN
  Result := Word16 ( A OR B SHL BitSizeOf ( Byte ) );
END; {* MakeWord16 *}

FUNCTION MakeInt32 ( A, B : Word16 ) : Int32;
BEGIN
  Result := Int32 ( A OR B SHL BitSizeOf ( Word16 ) );
END; {* MakeInt32 *}

FUNCTION HiWord16 ( L : Int32 ) : Word16;
BEGIN
  Result := Word16 ( Word32 ( L ) SHR BitSizeOf ( Word16 ) );
END; {* HiWord16 *}

FUNCTION LoWord16 ( L : Int32 ) : Word16;
BEGIN
  Result := Word16 ( L AND $FFFF );
END; {* LoWord16 *}

FUNCTION HiByte8 ( W : Word16 ) : Byte8;
BEGIN
  Result := Byte8 ( W SHR BitSizeOf ( Byte8 ) );
END;{* HiByte8 *}

FUNCTION LoByte8 ( W : Word16 ) : Byte8;
BEGIN
  Result := Byte8 ( W AND $FF );
END; {* LoByte8 *}

FUNCTION AnsiSameText ( CONST S1, S2 : string ) : Boolean;
BEGIN
   Result := AnsiCompareText ( s1, s2 ) = 0;
END;{* AnsiSameText *}

FUNCTION AnsiSameStr ( CONST S1, S2 : string ) : Boolean;
BEGIN
   Result := AnsiCompareStr ( s1, s2 ) = 0;
END;{* AnsiSameStr *}

FUNCTION QuotedStr;
VAR
i : Word;
BEGIN
   IF Pos ( SingleQuote, s ) = 0
   THEN BEGIN
      Result := SingleQuote + s + SingleQuote;
      Exit;
   END;
   Result := s;
   FOR i := Length ( Result ) DOWNTO 1
   DO BEGIN
     IF Result [i] = SingleQuote THEN Insert ( SingleQuote, Result, i );
   END;
   Result := SingleQuote + Result + SingleQuote;
END;{* QuotedStr *}

FUNCTION FindCmdLineSwitch;
VAR
s : TString;
i : Word;
BEGIN
   Result := False;
   IF ParamCount = 0 THEN Exit;
   FOR i := 1 TO ParamCount
   DO BEGIN
       s := ParamStr ( i );
       IF s [1] IN SwitchChars
       THEN BEGIN
           CASE IgnoreCase OF
             True :  Result := CompareText ( Switch, s ) = 0;
             False :  Result := CompareStr ( Switch, s ) = 0;
           END;{Case}
           IF Result THEN Exit;
       END;
   END;
END;{* FindCmdLineSwitch *}

FUNCTION DateTimeToTimeStamp ( DateTime : TDateTime ) : TTimeStamp;
VAR Tmp : Comp;
BEGIN
  Tmp := Trunc ( DateTime * MSecsPerDay );
  Result.Date := Tmp DIV MSecsPerDay + DateDelta;
  Result.Time := Abs ( Tmp ) MOD MSecsPerDay
END;{* DateTimeToTimeStamp *}

FUNCTION TimeStampToDateTime ( CONST TimeStamp : TTimeStamp ) : TDateTime;
VAR Tmp : Comp;
BEGIN
  Tmp := ( TimeStamp.Date - DateDelta ) * MSecsPerDay;
  IF Tmp > 0
    THEN Inc ( Tmp, TimeStamp.Time )
    ELSE Dec ( Tmp, TimeStamp.Time );
  TimeStampToDateTime := Tmp / MSecsPerDay
END;{* TimeStampToDateTime *}

FUNCTION MSecsToTimeStamp ( MSecs : Comp ) : TTimeStamp;
BEGIN
  Result.Date := MSecs DIV MSecsPerDay;
  Result.Time := MSecs MOD MSecsPerDay
END;{* MSecsToTimeStamp *}

FUNCTION TimeStampToMSecs ( CONST TimeStamp : TTimeStamp ) : Comp;
BEGIN
  TimeStampToMSecs := Comp ( TimeStamp.Date ) * MSecsPerDay + TimeStamp.Time
END;{* TimeStampToMSecs *}

FUNCTION EncodeTime ( Hour, Min, Sec, MSec : Word ) : TDateTime;
BEGIN
  IF ( Hour < 24 ) AND ( Min < 60 ) AND ( Sec < 60 ) AND ( MSec < 1000 )
  THEN Result := ( Hour * 3600000 + Min * 60000 + Sec * 1000 + MSec ) / MSecsPerDay
  ELSE Result := SysError;
END;{* EncodeTime *}

PROCEDURE DecodeTime ( Time : TDateTime; VAR Hour, Min, Sec, MSec : Word16 );
PROCEDURE Modulate ( Dividend : Int32; Divisor : Word16; VAR Res, Remainder : Word16 );
BEGIN
  Res := Dividend DIV Divisor;
  Remainder := Dividend MOD Divisor;
END;

VAR
I, J : Word16;
TS : TTimeStamp;
BEGIN
  TS := DateTimeToTimeStamp ( Time );
  Modulate ( TS.Time, MSecsPerMin, I, J );
  Modulate ( I, SecsPerMin, Hour, Min );
  Modulate ( J, MSecsPerSec, Sec, MSec );
END;{* DecodeTime *}

FUNCTION EncodeDate ( Year, Month, Day : Word ) : TDateTime;
CONST MonthOffset : ARRAY [1 .. 12] OF Integer
= (  - 94, - 63, - 400, - 369, - 339, - 308, - 278, - 247, - 216, - 186, - 155, - 125 );
BEGIN
  IF ( Year < 1 ) OR ( Year > 9999 ) OR ( Month < 1 ) OR ( Month > 12 ) OR ( Day < 1 ) OR
     ( Day > MonthLength ( Month, Year ) +
     Ord ( ( Month = 2 )
     AND IsLeapYear ( Year ) ) ) THEN
    { Problem ! ... };
  IF Month <= 2 THEN Dec ( Year );
  EncodeDate := Day + MonthOffset [Month] + ( Year - 1900 ) * 365 + Year DIV 4 - Year DIV 100 + Year DIV 400
END;{* EncodeDate *}

PROCEDURE DecodeDate ( Date : TDateTime; VAR Year, Month, Day : Word16 );
VAR
IntDate, Tmp1, Tmp2, Tmp3, Tmp4, Tmp5, Tmp6 : Integer;
BEGIN
  IntDate := Trunc ( Date );
  IF IntDate < LastGoodDate
  THEN BEGIN
      Year := 0;
      Month := 0;
      Day := 0;
      Exit;
  END;

  Inc ( IntDate, 693899 );
  Tmp1 := 30 * ( IntDate DIV 1460970 );
  Tmp2 := IntDate MOD 1460970;
  Tmp1 := Tmp1 + 3 * ( Tmp2 DIV 146097 );
  Tmp2 := Tmp2 MOD 146097;
  IF Tmp2 = 146096 THEN Inc ( Tmp1, 3 ) ELSE Inc ( Tmp1, Tmp2 DIV 36524 );
  Tmp3 := IntDate + ( Tmp1 - 2 ) + 1722644;
  Tmp5 := ( 20 * Tmp3 - 2442 ) DIV 7305;
  Tmp4 := Tmp3 - ( 1461 * Tmp5 ) DIV 4;
  Tmp6 := ( 10000 * Tmp4 ) DIV 306001;
  Day := Tmp4 - ( 306001 * Tmp6 ) DIV 10000;
  Month := Pred ( Tmp6 );
  Year := Tmp5 - 4716;

  IF Month > 12
  THEN BEGIN
      Dec ( Month, 12 );
      Inc ( Year );
  END;

END;{* DecodeDate *}

FUNCTION LongToDateTimeRec ( i : Longint ) : TDateTimeRec;
VAR
MSec : Word16;
D : DateTime;
BEGIN
  UnpackTime ( i, D );
  WITH D DO BEGIN
     MSec := 0;
     Result.Date := EncodeDate ( Year, Month, Day );
     Result.Time := EncodeTime ( Hour, Min, Sec, MSec );
  END;
END;{* LongToDateTimeRec  *}

FUNCTION FileDateToDateTime ( DosDateTime : Longint ) : TDateTime;
VAR
DT : TDateTimeRec;
BEGIN
  DT := LongToDateTimeRec ( DosDateTime );
  Result := DT.Date + DT.Time;
END;{* FileDateToDateTime *}

FUNCTION DateTimeRecToLong ( DT : TDateTimeRec ) : Integer;
VAR
D : DateTime;
MSec,
L, H : Word16;
BEGIN
   Result := 0;
   WITH D DO BEGIN
      DecodeDate ( DT.Date, Year, Month, Day );
      DecodeTime ( DT.Time, Hour, Min, Sec, MSec );
      IF ( Year < 1980 ) OR ( Year > 2099 )
      THEN  { return 0 }
      ELSE BEGIN
        L := ( Sec DIV 2 ) OR ( Min * 32 ) OR ( Hour * 2048 );
        H := Day OR ( Month * 32 ) OR ( ( Year - 1980 ) * 512 );
        Result := MakeInt32 ( L, H );
      END;
   END;
END;{* DateTimeRecToLong *}

FUNCTION DateTimeToFileDate ( MyDateTime : TDateTime ) : Int32;
VAR
DT : TDateTimeRec;
BEGIN
  DT.Date := MyDateTime;
  DT.Time := MyDateTime;
  Result := DateTimeRecToLong ( DT );
END;{* DateTimeToFileDate *}

FUNCTION SystemTimeToDateTime ( CONST SystemTime : TSystemTime ) : TDateTime;
BEGIN
   WITH SystemTime
   DO BEGIN
        Result := EncodeDate ( wYear, wMonth, wDay ) +
                  EncodeTime ( wHour, wMinute, wSecond, wMilliseconds );
   END;
END;{* SystemTimeToDateTime *}

PROCEDURE DateTimeToSystemTime ( DateTime : TDateTime; VAR STime : TSystemTime );
BEGIN
   WITH STime DO BEGIN
      DecodeDate ( DateTime, wYear, wMonth, wDay );
      DecodeTime ( DateTime, wHour, wMinute, wSecond, wMilliSeconds );
   END;
END;{* DateTimeToSystemTime *}

{ utility functions for seek/replace functions }
FUNCTION IsMarked ( i : Integer; s2 : String ) : Boolean;
BEGIN
    Result :=
    ( ( i = 1 ) OR ( NOT IsAlphaNumUnderscore ( s2 [Pred ( i ) ] ) ) )
   AND
    ( ( i >= Length ( s2 ) ) OR ( NOT IsAlphaNumUnderscore ( s2 [Succ ( i ) ] ) ) );
END;

FUNCTION IsMarkedEx ( i, z : Integer; s2 : String ) : Boolean;
BEGIN
(*
   Result :=
           ( ( NOT IsAlphaNumUnderscore ( s2 [pred ( i ) ] ) )
       AND ( i + z >= Length ( s2 ) ) )                             { ' xxx'}
   OR
           ( ( NOT IsAlphaNumUnderscore ( s2 [pred ( i ) ] ) )
       AND ( NOT IsAlphaNumUnderscore ( s2 [i + z] ) ) )            { ' xxx ' }
   OR ( ( i = 1 ) AND ( i + z >= Length ( s2 ) ) )                  { 'xxx' }
   OR ( ( i = 1 ) AND ( NOT IsAlphaNumUnderscore ( s2 [i + z] ) ) ); { 'xxx '}
*)
    Result :=
        ( ( i = 1 ) OR ( NOT IsAlphaNumUnderscore ( s2 [pred ( i ) ] ) ) )
      AND
        ( ( i + z >= Length ( s2 ) ) OR ( NOT IsAlphaNumUnderscore ( s2 [i + z] ) ) );
END;

FUNCTION FindAndReplace ( CONST Src, TheOld, TheNew : String; IgnoreCase, WholeWords : Boolean ) : TString;
{ generic find/replace function }
VAR
b : Boolean;
s1, s2, Dest : TString;
Loc : ARRAY [1..255] OF Word;
k, i, j, z : Word;

BEGIN
    FindAndReplace := Src;
    Dest := Src;
    IF ( TheOld = '' ) OR ( Dest = '' ) THEN exit;
    s1 := TheOld;
    s2 := Dest;
    IF ignorecase THEN s1 := uppercase ( s1 );
    IF ignorecase THEN s2 := uppercase ( s2 );
    IF Pos ( s1, s2 ) = 0 THEN exit;

    z := length ( TheOld );

    IF ( Not WholeWords )
    THEN BEGIN
       IF z = 1  { single char }
       THEN BEGIN
          FOR i := length ( Dest ) DOWNTO 1
          DO BEGIN
              IF s2 [i] = s1 [1] THEN BEGIN
                 Delete ( s2, i, 1 );
                 Insert ( TheNew, s2, i );
                 Delete ( Dest, i, 1 );
                 Insert ( TheNew, Dest, i );
              END;
          END;
          FindAndReplace := Dest;
          exit;
       END ELSE
       WHILE 0 = 0 DO BEGIN
         i := pos ( s1, s2 );
         IF i = 0 THEN break;
         Delete ( s2, i, z ); {remove old}
         Insert ( TheNew, s2, i );
         Delete ( Dest, i, z ); {remove old}
         Insert ( TheNew, Dest, i );
       END;
       FindAndReplace := Dest;
       exit;
    END; {WholeWords=False}

    k := 0;
    j := 0;
    Fillchar ( Loc, Sizeof ( Loc ), 0 );

    { WholeWords=True }
    IF z = 1  { single char }
    THEN BEGIN
          FOR i := length ( Dest ) DOWNTO 1
          DO BEGIN
              IF  ( s2 [i] = s1 [1] ) AND ( IsMarked ( i, s2 ) )
              THEN BEGIN
                 Delete ( s2, i, 1 );
                 Insert ( TheNew, s2, i );
                 Delete ( Dest, i, 1 );
                 Insert ( TheNew, Dest, i );
              END;
          END;
          FindAndReplace := Dest;
          exit;
    END
    ELSE
     WHILE 0 = 0 DO BEGIN
         i := pos ( s1, s2 );
         IF i = 0 THEN break;
         b :=  IsMarkedEx ( i, z, s2 );
         IF b THEN BEGIN
            inc ( k );
            Delete ( s2, i, z ); {remove old}
            Insert ( TheNew, s2, i );
            Delete ( Dest, i, z ); {remove old}
            Insert ( TheNew, Dest, i );
         END ELSE BEGIN
            inc ( j );
            Loc [j] := succ ( i );  {insert #3 after i to break word}
            Insert ( #3, s2, Loc [j] );
            Insert ( #3, Dest, Loc [j] );
         END;
     END;

     IF j > 0
     THEN FOR i := j DOWNTO 1
     DO BEGIN
         Delete ( Dest, Loc [i], 1 );
     END;
     FindAndReplace := Dest;
END;{ * FindAndReplace *}

FUNCTION HasQuotes ( CONST s : String; VAR start, stop : word ) : Word;
{ return the number of quotation marks in a string - and also
  report the location of the first, and the last quote character
}
VAR
i : Word;
BEGIN
   Result := 0;
   start := 0;
   stop := 0;
   FOR i := 1 TO length ( s )
   DO BEGIN
       IF s [i] IN [DoubleQuote, SingleQuote]
       THEN BEGIN
          IF start = 0 THEN start := i;
          stop := i;
          inc ( Result );
       END;
   END;
END;

FUNCTION RemoveQuotes ( s : String ) : TString;
{ remove all quote characters from a string }
VAR
i : Word;
BEGIN
   FOR i := length ( s ) DOWNTO 1
     DO IF s [i] IN [DoubleQuote, SingleQuote]
       THEN Delete ( s, i, 1 );
   Result := s;
END;

FUNCTION WithinQuotes ( CONST s2 : String; CONST i : Word ) : Boolean;
{ return whether the character at index i is within quotation marks }
VAR
stt, stp : Word;
BEGIN
  Result := False;
  IF HasQuotes ( s2, stt, stp ) > 1
    THEN Result := ( stt < i ) AND ( stp > i );
END;

FUNCTION SeekReplace
         ( CONST Src, TheOld, TheNew : String;
         IgnoreCase, WholeWords : Boolean ) : TString;
{ specialised find/replace function for formatting TDateTime stuff }
VAR
b : Boolean;
s1, s2, Dest : String [255];
Loc : ARRAY [1..255] OF Byte;
k, i, j, z : Word;

BEGIN
    Result := Src;
    Dest := Src;
    IF ( TheOld = '' ) OR ( Dest = '' ) THEN exit;
    s1 := TheOld;
    s2 := Dest;
    IF ignorecase THEN s1 := uppercase ( s1 );
    IF ignorecase THEN s2 := uppercase ( s2 );
    IF Pos ( s1, s2 ) = 0 THEN exit;

    z := length ( TheOld );
    k := 0;
    j := 0;
    IF ( Not WholeWords )
    THEN BEGIN
       IF z = 1  { single char }
       THEN BEGIN
          FOR i := length ( Dest ) DOWNTO 1
          DO BEGIN
              b := s2 [i] = s1 [1];
              IF b THEN IF Not WithinQuotes ( s2, i )
              THEN BEGIN
                 Delete ( s2, i, 1 );
                 Insert ( TheNew, s2, i );
                 Delete ( Dest, i, 1 );
                 Insert ( TheNew, Dest, i );
              END;
          END;
          Result := Dest;
          exit;
       END ELSE
       WHILE 0 = 0 DO BEGIN
         i := pos ( s1, s2 );
         IF ( i = 0 ) OR ( j >= length ( s2 ) ) THEN break;
         inc ( j );
         IF WithinQuotes ( s2, i )
         THEN BEGIN
           insert ( #3, s2, succ ( i ) );
           insert ( #3, dest, succ ( i ) );
         END
         ELSE BEGIN
           Delete ( s2, i, z ); {remove old}
           Insert ( TheNew, s2, i );
           Delete ( Dest, i, z ); {remove old}
           Insert ( TheNew, Dest, i );
         END;
       END;
       FOR i := 1 TO length ( Dest ) DO IF dest [i] = #3 THEN delete ( dest, i, 1 );
       Result := Dest;
       exit;
    END; {WholeWords=False}

    k := 0;
    j := 0;
    Fillchar ( Loc, Sizeof ( Loc ), 0 );
    { WholeWords=True }
      IF z = 1  { single char }
      THEN BEGIN
          FOR i := length ( Dest ) DOWNTO 1
          DO BEGIN
              IF  ( s2 [i] = s1 [1] ) AND ( IsMarked ( i, s2 ) )
              THEN BEGIN
                 IF Not WithinQuotes ( s2, i )
                 THEN BEGIN
                    Delete ( s2, i, 1 );
                    Insert ( TheNew, s2, i );
                    Delete ( Dest, i, 1 );
                    Insert ( TheNew, Dest, i );
                 END;
              END;
          END;
          Result := Dest;
          exit;
     END ELSE
     WHILE 0 = 0 DO BEGIN
         i := pos ( s1, s2 );
         IF i = 0 THEN break;
         b := IsMarkedEx ( i, z, s2 );
         IF ( b ) AND ( WithinQuotes ( s2, i ) )
         THEN BEGIN
            b := false;
            inc ( j );
            loc [j] := succ ( i );
            Insert ( #3, s2, Loc [j] );
            Insert ( #3, dest, Loc [j] );
         END;

         IF b THEN BEGIN
            inc ( k );
            Delete ( s2, i, z ); {remove old}
            Insert ( TheNew, s2, i );
            Delete ( Dest, i, z ); {remove old}
            Insert ( TheNew, Dest, i );
         END ELSE BEGIN
            inc ( j );
            Loc [j] := succ ( i );  {insert #3 after i to break word}
            Insert ( #3, s2, Loc [j] );
            Insert ( #3, Dest, Loc [j] );
         END;
     END;

     IF j > 0
     THEN FOR i := j DOWNTO 1
     DO BEGIN
         Delete ( Dest, Loc [i], 1 );
     END;
     Result := Dest;
END;

{@@}FUNCTION  wFormatTime ( Format : String; Time : TDateTime ) : TString;
VAR
Hour, Min, Sec, MSec : Word16;
h, m, s, ms : String [5];
s2 : String [32];
s3 : String [128];
BEGIN
  DecodeTime ( Time, Hour, Min, Sec, MSec ); { get MSec }
  s2 := '';
  s3 := Format;

  IF pos ( 'am/pm', LowerCase ( Format ) ) > 0
  THEN BEGIN
     s2 := 'am';
     IF Hour > 11
     THEN BEGIN
        IF Hour > 12 THEN Dec ( Hour, 12 );
        IF Pos ( '/PM', Format ) > 0 THEN s2 := 'PM' ELSE s2 := 'pm';
     END ELSE IF Pos ( 'AM/', Format ) > 0 THEN s2 := 'AM';
     s3 := SeekReplace ( s3, 'AM/PM', s2, true, false );
  END ELSE
  IF pos ( 'a/p', LowerCase ( Format ) ) > 0
  THEN BEGIN
     s2 := 'a';
     IF Hour > 11
     THEN BEGIN
        IF Hour > 12 THEN Dec ( Hour, 12 );
        IF Pos ( '/P', Format ) > 0 THEN s2 := 'P' ELSE s2 := 'p';
     END ELSE IF Pos ( 'A/', Format ) > 0 THEN s2 := 'A';
     s3 := SeekReplace ( s3, 'a/m', s2, false, false );
     s3 := SeekReplace ( s3, 'A/M', s2, false, false );
  END ELSE
  IF pos ( 'ampm', Format ) > 0
  THEN BEGIN
     s2 := TimeAMString;
     IF Hour > 11
     THEN BEGIN
        IF Hour > 12 THEN Dec ( Hour, 12 );
        s2 := TimePMString;
     END;
     s3 := SeekReplace ( s3, 'ampm', s2, false, false );
  END;

  { convert time to string }
  h := IntToStr ( Hour );
  m := IntToStr ( Min );
  s := IntToStr ( Sec );
  ms := IntToStr ( MSec );

  { format }
  IF length ( h ) = 1 THEN IF pos ( 'hh', Format ) > 0 THEN h := '0' + h;
  IF length ( m ) = 1 THEN IF pos ( 'nn', Format ) > 0 THEN m := '0' + m;
  IF length ( m ) = 1 THEN IF pos ( 'mm', Format ) > 0 THEN m := '0' + m;
  IF length ( s ) = 1 THEN IF pos ( 'ss', Format ) > 0 THEN s := '0' + s;

  s3 := SeekReplace ( s3, 'hh', h, true, false );
  s3 := SeekReplace ( s3, 'h', h, false, true );

  s3 := SeekReplace ( s3, 'nn', m, true, false );
  s3 := SeekReplace ( s3, 'n', m, false, true );

  s3 := SeekReplace ( s3, 'mm', m, true, false );
  s3 := SeekReplace ( s3, 'm', m, false, true );

  s3 := SeekReplace ( s3, 'ss', s, true, false );
  s3 := SeekReplace ( s3, 's', s, false, true );

  IF ( Pos ( ':', s3 ) > 0 ) AND ( TimeSeparator <> ':' )
   THEN s3 := SeekReplace ( s3, ':', TimeSeparator, false, false );

  Result := s3;
END;{* wFormatTime *}

FUNCTION TimeToStr ( Time : TDateTime ) : TString;
{ use the format specified in: LongTimeFormat }
BEGIN
    Result := wFormatTime ( LongTimeFormat, Time );
END;{* TimeToStr *}

FUNCTION  FileDateToStr ( FTime : Longint ) : TString;
BEGIN
   Result := DateTimeToStr ( FileDateToDateTime ( FTime ) );
END;{* FileDateToStr *}

FUNCTION FormatDate ( Format : String; Date : TDateTime ) : TString;
VAR
Year, Month, Day : Word16;
d, m, y : String [8];
s : String [255];
s1 : String [2];

BEGIN
  DecodeDate ( Date, Year, Month, Day );
  s := Format;

  d := IntToStr ( Day );
  m := IntToStr ( Month );
  y := IntToStr ( Year );

  { format }
  IF length ( d ) = 1 THEN IF pos ( 'dd', Format ) > 0 THEN d := '0' + d;
  IF length ( m ) = 1 THEN IF pos ( 'mm', Format ) > 0 THEN m := '0' + m;
  IF pos ( 'yyyy', Format ) = 0 THEN Delete ( y, 1, 2 );

  { days }
  IF Pos ( 'dddd', lowercase ( s ) ) > 0
  THEN BEGIN
    s := SeekReplace ( s, 'dddd', LongDayNames [DayOfWeek ( Date ) ], true, false );
  END;

  IF Pos ( 'ddd', lowercase ( s ) ) > 0
  THEN s := SeekReplace ( s, 'ddd', ShortDayNames [DayOfWeek ( Date ) ], true, false );

  { months }
  IF Pos ( 'mmmm', lowercase ( s ) ) > 0
  THEN s := SeekReplace ( s, 'mmmm', LongMonthNames [Month], true, false );

  IF Pos ( 'mmm', lowercase ( s ) ) > 0
  THEN s := SeekReplace ( s, 'mmm', LongMonthNames [Month], true, false );

  { others }
  s := SeekReplace ( s, 'dd', d, true, false );
  s := SeekReplace ( s, 'd', d, true, true );

  s := SeekReplace ( s, 'mm', m, true, false );
  s := SeekReplace ( s, 'm', m, true, true );

  s := SeekReplace ( s, 'yyyy', y, true, false );
  s := SeekReplace ( s, 'yy', y, true, false );

    { slash }
  IF ( Pos ( '/', s ) > 0 ) AND ( DateSeparator <> '/' )
  THEN s := SeekReplace ( s, '/', DateSeparator, false, false );
  { end format }
  Result := s;
END;{* FormatDate *}

FUNCTION DateToStr ( Date : TDateTime ) : TString;
{ use the format specified in: ShortDateFormat }
BEGIN
   Result := FormatDate ( ShortDateFormat, Date );
END;{* DateToStr *}

FUNCTION DateTimeToStr ( DateTime : TDateTime ) : TString;
BEGIN
   Result := DateToStr ( DateTime ) + ' ' + TimeToStr ( DateTime );
END;{* DateTimeToStr *}

FUNCTION FormatDateTime ( CONST Format : string; DateTime : TDateTime ) : TString;
VAR
s1,
s, s3 : String [255];
i, j, k : byte;
tmp : String [1];
BEGIN
   s := '';
   tmp := '';
   s3 := Format;
   s3 := SeekReplace ( s3, 'dddddd', LongDateFormat, false, false );
   s3 := SeekReplace ( s3, 'ddddd', ShortDateFormat, false, false );
   s3 := SeekReplace ( s3, 'tt', LongTimeFormat, false, true );
   s3 := SeekReplace ( s3, 't', ShortTimeFormat, false, true );
   {}
   i := pos ( 'hh', s3 );
   IF i > 0 THEN BEGIN
      j := i;
      k := 0;
      FOR j := i TO length ( s3 )
      DO BEGIN
          inc ( k );
          s := s + s3 [j];
          IF s3 [j] = #32 THEN break;
      END;
      Delete ( s3, i, k );
   END;

   { ampm, am/pm, a/p: @@ very crude !! @@ }
   s1 := 'am/pm';
   i := pos ( s1, lowercase ( s3 ) );
   IF i > 0 THEN BEGIN
      IF s3 [pred ( i ) ] <> #32 THEN tmp := ' ';
      s := s + tmp + copy ( s3, i, length ( s1 ) );
      Delete ( s3, i, length ( s1 ) );
   END;

   s1 := 'ampm';
   i := pos ( s1, lowercase ( s3 ) );
   IF i > 0 THEN BEGIN
      IF s3 [pred ( i ) ] <> #32 THEN tmp := ' ';
      s := s + tmp + copy ( s3, i, length ( s1 ) );
      Delete ( s3, i, length ( s1 ) );
   END;

   s1 := 'a/p';
   i := pos ( s1, lowercase ( s3 ) );
   IF i > 0 THEN BEGIN
      IF s3 [pred ( i ) ] <> #32 THEN tmp := ' ';
      s := s + tmp + copy ( s3, i, length ( s1 ) );
      Delete ( s3, i, length ( s1 ) );
   END;

   Result := RemoveQuotes ( FormatDate ( s3, DateTime ) + '' + wFormatTime ( s, DateTime ) );
END;{* FormatDateTime *}

FUNCTION DayOfWeek ( Date : TDateTime ) : Integer;
VAR
Day, Month, Year : Word16;
BEGIN
   DecodeDate ( Date, Year, Month, Day );
   Result := Succ ( GetDayOfWeek ( Day, Month, Year ) );
END;{* DayOfWeek *}

FUNCTION SameTime ( CONST A, B : TDateTime ) : Boolean;
VAR
aa, bb : TSystemTime;
BEGIN
  DateTimeToSystemTime ( A, aa );
  DateTimeToSystemTime ( B, bb );
  Result :=
        ( aa.wHour = bb.wHour )
  AND   ( aa.wMinute = bb.wMinute )
  AND   ( aa.wSecond = bb.wSecond )
  AND   ( aa.wMilliseconds = bb.wMilliSeconds )

END;{* SameTime *}

FUNCTION SameDate ( CONST A, B : TDateTime ) : Boolean;
VAR
aa, bb : TSystemTime;
BEGIN
  DateTimeToSystemTime ( A, aa );
  DateTimeToSystemTime ( B, bb );
  Result :=
        ( aa.wYear = bb.wYear )
  AND   ( aa.wMonth = bb.wMonth )
  AND   ( aa.wDay = bb.wDay )
END;{* SameDate *}

FUNCTION SameDateTime ( CONST A, B : TDateTime ) : Boolean;
BEGIN
   Result := ( SameDate ( A, B ) ) AND ( SameTime ( A, B ) );
END;{* SameDateTime *}

FUNCTION CompareTime ( CONST A, B : TDateTime ) : TValueRelationship;
VAR
aa, bb : TSystemTime;
BEGIN
  Result := EqualsValue;
  DateTimeToSystemTime ( A, aa );
  DateTimeToSystemTime ( B, bb );
  IF    ( aa.wHour = bb.wHour )
  AND   ( aa.wMinute = bb.wMinute )
  AND   ( aa.wSecond = bb.wSecond )
  AND   ( aa.wMilliseconds = bb.wMilliSeconds )
  THEN {}
  ELSE
  IF    ( aa.wHour > bb.wHour ) THEN Result := GreaterThanValue
  ELSE
  IF    ( aa.wHour < bb.wHour ) THEN Result := LessThanValue
  ELSE
  IF    ( aa.wMinute > bb.wMinute ) THEN Result := GreaterThanValue
  ELSE
  IF    ( aa.wMinute < bb.wMinute ) THEN Result := LessThanValue
  ELSE
  IF    ( aa.wSecond > bb.wSecond ) THEN Result := GreaterThanValue
  ELSE
  IF    ( aa.wSecond < bb.wSecond ) THEN Result := LessThanValue
  ELSE
  IF    ( aa.wMilliseconds > bb.wMilliSeconds ) THEN Result := GreaterThanValue
  ELSE
  IF    ( aa.wMilliseconds < bb.wMilliSeconds ) THEN Result := LessThanValue
END;{* CompareTime *}

FUNCTION CompareDate ( CONST A, B : TDateTime ) : TValueRelationship;
VAR
aa, bb : TSystemTime;
BEGIN
  Result := EqualsValue;
  DateTimeToSystemTime ( A, aa );
  DateTimeToSystemTime ( B, bb );
  IF    ( aa.wYear = bb.wYear )
  AND   ( aa.wMonth = bb.wMonth )
  AND   ( aa.wDay = bb.wDay )
  THEN {}
  ELSE
  IF    ( aa.wYear > bb.wYear ) THEN Result := GreaterThanValue
  ELSE
  IF    ( aa.wYear < bb.wYear ) THEN Result := LessThanValue
  ELSE
  IF    ( aa.wMonth > bb.wMonth ) THEN Result := GreaterThanValue
  ELSE
  IF    ( aa.wMonth < bb.wMonth ) THEN Result := LessThanValue
  ELSE
  IF    ( aa.wDay > bb.wDay ) THEN Result := GreaterThanValue
  ELSE
  IF    ( aa.wDay < bb.wDay ) THEN Result := LessThanValue
END;{* CompareDate *}

FUNCTION CompareDateTime ( CONST A, B : TDateTime ) : TValueRelationship;
VAR
D : TValueRelationship;
BEGIN
  D := CompareDate ( A, B );
  CASE D OF
    GreaterThanValue, LessThanValue :  Result := D;
      ELSE Result := CompareTime ( A, B );
  END; { case }
END;{* CompareDateTime *}

FUNCTION StringtoCharset ( CONST S : string; VAR c : TSysCharSet ) : Boolean;
VAR
i : Integer;
BEGIN
  c := [];
  FOR i := 1 TO Length ( s ) DO Include ( c, s [i] );
  Result := Length ( s ) > 0;
END;{* StringtoCharset *}

FUNCTION IsDelimiter ( CONST Delimiters, S : string; Index : Integer ) : Boolean;
VAR c : TSysCharSet;
BEGIN
  StringtoCharset ( Delimiters, c );
  Result := s [Succ ( Index ) ] IN c;
END;{* IsDelimiter *}

FUNCTION IsPathDelimiter ( CONST S : string; Index : Integer ) : Boolean;
BEGIN
  Result := s [Succ ( Index ) ] = DirSeparator;
END;{* IsPathDelimiter *}

FUNCTION LastDelimiter ( CONST Delimiters, S : string ) : Integer;
VAR
c : Set OF Char;
i : Integer;
BEGIN
  Result := 0;
  StringtoCharset ( Delimiters, c );
  FOR i := Length ( s ) DOWNTO 1
  DO IF s [i] IN c
  THEN BEGIN
      Result := i;
      Exit;
  END;
END;{* LastDelimiter *}


{**********************************************************************}
{**********************************************************************}
{**********************************************************************}
{**********************************************************************}
{**********************************************************************}

{ (initialization) }
TO BEGIN DO BEGIN
 {$ifdef UseW32API}    { get the correct Win32 version (Delphi) }
  WITH VerInfo
  DO BEGIN
     dwOSVersionInfoSize := Sizeof ( VerInfo );
     GetVersionEx ( VerInfo );
     Win32Platform := dwPlatformId;
  END;
 {$endif}
END;{ to begin do }

{ (finalization) }
TO END DO BEGIN
  { from Dos Unit }
  {$ifndef UseW32API}
  WHILE FindList <> nil
  DO BEGIN
      VAR i : Integer = IOResult;
      CloseFind ( @FindList );
      InOutRes := i
  END;
  {$endif}
END;{ to end do }

END.

